#ifndef LEXER_H
#define LEXER_H

#include <stddef.h>

typedef struct {
    size_t index;
    int line, col;
} Position;

typedef enum {
    TokenTypeEof,
    TokenTypeInvalidChar,
    TokenTypeInt,
    TokenTypePlus,
    TokenTypeMinus,
    TokenTypeAsterisk,
    TokenTypeSlash,
    TokenTypeLParen,
    TokenTypeRParen,
} TokenType;

typedef struct {
    TokenType type;
    size_t index, length;
    int line, col;
} Token;

typedef struct {
    const char* text;
    size_t index, length;
    int line, col;
} Lexer;

void lexer(Lexer* lexer, const char* text, size_t length);
Token lexer_next(Lexer* lexer);

#endif
